{ 
Vectorul initial este construit ca un vector constant de caractere, pe linii. 
In acest vector C ocupa pozitia 1, D pozitia 2,..., B pozitia 5, etc.

Vom folosi un vector de constante care contine, pentru fiecare din cele 5
patrate, cate 2 vectori, indicand noile pozitii a caracterelor din vectorul
anterior in vectorul care se va obtine in urma rotirii patratului la
stanga/dreapta.
Astfel, in urma unei rotiri la dreapta in patratul 1, C va ocupa pozitia 2,
D pozitia 3,..., B pozitia 1, etc.

Avand acest vector de rotatii construit, se procedeaza astfel:
* pentru fiecare caracter din fisierul de intrare:
- se citeste caracterul
- in vectorul LAux se pastreaza vectorul anterior (la inceput vectorul initial)
- se indica in LAux[0] lungimea stringului (specific Pascal)
- in vectorul NewL se va construi noul string rezultat in urma rotirilor
- se rotesc cele 5 patrate conform celor doi vectori, avand grija de fiecare
  data sa se pastreze in LAux noul vector rezultat
- se cauta in vectorul initial StrInit caracterul care trebuie codificat
  si se retine pozitia lui
- se scrie in fisierul de iesire caracterul corespunzator din vectorul
  nou creat NewL, care devine apoi vectorul curent de lucru
}

Program Cod;
Const NMax = 44;
Type IntegerVector = Array[1..NMax] Of Integer;
     CharVector = String[NMax];

Const StrInit: CharVector = 'CDEFBGAHabcdefghijuUZkwTJlvxtsrqponmRKQLPONM';

      Rot: Array[1..5, 0..1] Of IntegerVector =
      (((2,3,4,6,1,8,5,15,9,10,11,7,12,13,14,16,17,18,19,20,21,22,
      23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44),
      (5,1,2,3,7,4,12,6,9,10,11,13,14,15,8,16,17,18,19,20,21,22,
      23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44)),
      ((1,2,3,4,5,6,7,8,10,11,12,20,13,14,15,16,17,18,9,24,21,22,19,30,25,26,
      23,27,28,29,31,32,33,34,35,36,37,38,39,40,41,42,43,44),
      (1,2,3,4,5,6,7,8,19,9,10,11,13,14,15,16,17,18,23,12,21,22,27,20,25,26,
      28,29,30,24,31,32,33,34,35,36,37,38,39,40,41,42,43,44)),
      ((1,2,3,4,5,6,7,8,9,10,11,13,14,15,21,16,17,18,19,12,25,22,23,20,33,
      26,27,28,29,24,30,31,32,34,35,36,37,38,39,40,41,42,43,44),
      (1,2,3,4,5,6,7,8,9,10,11,20,12,13,14,16,17,18,19,24,15,22,23,30,21,
      26,27,28,29,31,32,33,25,34,35,36,37,38,39,40,41,42,43,44)),
      ((1,2,3,4,5,6,7,8,9,10,11,12,13,14,16,17,18,22,19,20,15,26,23,24,21,
      36,27,28,29,30,31,32,25,33,34,35,37,38,39,40,41,42,43,44),
      (1,2,3,4,5,6,7,8,9,10,11,12,13,14,21,15,16,17,19,20,25,18,23,24,33,
      22,27,28,29,30,31,32,34,35,36,26,37,38,39,40,41,42,43,44)),
      ((1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,
      26,27,28,29,31,32,33,38,34,35,36,30,40,37,44,39,41,42,43),
      (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,
      26,27,28,29,37,30,31,32,34,35,36,39,33,41,38,42,43,44,40)));

Var P, S: IntegerVector;
    L: CharVector;
    i: Integer;

Procedure Encode;
Var NewL, LAux: CharVector;
    i, j: Integer;
    C: Char;
Begin
  Read(C); {citeste caracter }
  LAux := L; {LAux - vector de lucru }
  LAux[0] := Chr(NMax); {pun lungimea vectorului }
  NewL[0] := Chr(NMax);
  For i := 1 To 5 Do {fac cele 5 rotatii }
    Begin {determin noul vector NewL }
      For j := 1 To NMax Do NewL[j] := LAux[Rot[P[i],S[i],j]];
      LAux := NewL; {acesta devine vectorul de lucru }
    End;
  j := 0;
  Repeat Inc(j) Until StrInit[j]=C;{caut pozitia lui C in vectorul initial}
  Write(NewL[j]); {scriu caracterul codificat }
  L := NewL; {pastrez in L configuratia - de aici }
End;         {pornesc pentru codificaea caracterului }
{urmator}

Begin
  Assign(Input, 'cod.in'); Reset(Input);
  Assign(Output, 'cod.out'); Rewrite(Output);
  For i := 1 To 5 Do Read(P[i]); ReadLn; {in P - ordinea de rotire }
  For i := 1 To 5 Do Read(S[i]); ReadLn; {in S - sensul de rotire }
  L := StrInit; {pun sirul initial in L }
  While Not Eoln Do Encode; {codific fiecare caracter }
  WriteLn;
  Close(Input); Close(Output);
End.

