//prof. Emanuela Cerchez; 100 puncte
#include <fstream.h>
#include <string.h>
#include <stdlib.h>
#define InFile  "reteta.in"
#define OutFile "reteta.out"
#define LgMax 1001
#define NrMax 100
#define LgP 21


int nr;         //numarul de produse
int n;          //lungime reteta
char s[LgMax];  //reteta
long int timp;

struct Produs
       {char nume[LgP];
        long int cant; } P[NrMax]; //produsele in ordine alfabetica

void read();
long int det_timp();
void cantitati();
void write();
int cauta(char *);

int main()
{
 read();
 timp=det_timp();
 cantitati();
 write();
 return 0;
}


void read()
{
 int i, nr, d, j;
 ifstream fin (InFile);
 fin.getline(s,LgMax-1);
 n=strlen(s);
 fin.close();
}


void write()
{
int i;
ofstream fout(OutFile);
fout<<timp<<'\n';
for (i=0; i<nr; i++)
    fout<<P[i].nume<<' '<<P[i].cant<<'\n';
fout.close();
}


long int det_timp()
//pentru a determina timpul total insumez numerele aflate dupa parantezele inchise
//elimin apoi aceste numere din sir
{
char *p=s, *q;
int a;
long int timp=0;
while (p)
      {p=strchr(s,')');
       if (p)
          {
          q=p+1;
          //sar eventualele spatii
          while (q[0]==' ') q++;
          //identific numarul
          a=q[0]-'0';
          if (q[1]>='0' && q[1] <='9')
             {a=a*10+q[1]-'0'; q++;}
          timp+=a;
          //sterg din sir caracterele de la p+1 la q inclusiv
          *p=NULL;
          strcat(s,q+1);
          }

      }
return timp;
}


void cantitati()
{
char *p=s;
int poz;
p=strtok(s," ()");
while (p)
      {
      //p indica numele unui produs
      poz=cauta(p);
      //extrag cantitatea
      p=strtok(NULL," ()");
      P[poz].cant+=atoi(p);
      //extrag urmatorul produs
      p=strtok(NULL," ()");
      }
}


int cauta(char * x)
//cauta secvential produsul x in vectorul de produse
//daca produsul este gasit se returneaza pozitia sa
//daca produsul nu este gasit se insereaza in vectorul de produse, astfel incat vectorul de produse sa ramana sortat.
{
int i, j;
for (i=0; i<nr && strcmp(P[i].nume,x)<0; i++);
if (strcmp(x, P[i].nume)==0) return i;
//deplasez elementele de la pozitia i la nr-1 cu o pozitie la stanga
for (j=nr; j>i; j--) P[j]=P[j-1];
nr++;
strcpy(P[i].nume,x);
P[i].cant=0;
return i;
}
