#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#define MAXN 100
#define MAXLEN 100
#define INFILE "top.in"
#define OUTFILE "top.out"
#define LAFEL "SAME"
#define SUS "UP"
#define JOS "DOWN"

int n, dir[MAXN], link[MAXN];
/*
  dir[i]=1 daca melodia i a urcat in top;
  dir[i]=-1 daca melodia i a coborat in top;
  dir[i]=0 daca melodia i a ramas in top pe aceeasi pozitie
*/;
char *s[MAXN];
/*s este un vector de siruri de caractere, in care vom retine numele
  melodiilor in ordinea din saptamana curenta */

void citire ( void )
{
  int i;
  char tmp[10];
  FILE *f=fopen (INFILE, "rt");
  fscanf (f, "%dn", &n);
  for (i=0; i<n; i++)
	{
	  s[i]=(char *) malloc ((MAXLEN+1)*sizeof(char));
	  fscanf (f, "%s", s[i]);
	  fscanf (f, "%s", tmp);
	  if (!strcmp (tmp, SUS)) dir[i]=1;
	  if (!strcmp (tmp, JOS)) dir[i]=-1;
	}
  fclose(f);
}

void rezolvare ( void )
{
  int i, j;
  for (i=0; i<n; i++) link[i]=i;
  i=j=0; //plec de la inceputul listei de melodii
  while (j<n)
	{ //cat timp mai am melodii care au coborat
	  while (i<n && dir[i]==0) i++; //caut prima melodie care s-a miscat in top
	  while (j<n && dir[j]!=-1) j++;//caut prima melodie care a coborat
	  //si (daca se poate)
	  if (j<n) link[i]=j; //o pun pe pozitia i
	  i++; j++; //trec mai departe in "sus" in ambele cazuri
	}

  j=n-1; i=n-1; //acum plec de la sfarsitul listei
  while (j>=0) //cat timp mai am melodii care au urcat
	{
	  while (i>=0 && dir[i]==0) i--;//caut prima melodie care s-a miscat in top
	  while (j>=0 && dir[j]!=1) j--;//caut prima melodie care a urcat
	  //si (daca se poate)
	  if (j>=0) link[i]=j; //o pun pe pozitia i
	  i--; j--; //trec mai departe in "jos" in ambele cazuri
	}
}

void afisare ( void )
{
  FILE *f=fopen (OUTFILE, "wt");
  int i;
  for (i=0; i<n; i++) fprintf (f, "%sn", s[link[i]]);
  fclose (f);
}

int main ( void )
{
  citire();
  rezolvare();
  afisare();
  return 0;
}
