#include <stdio.h>

char sablon[10][16] = { "####.##.##.####",
                        ".#..#..#..#..#.",
                        "###..#####..###",
                        "###..####..####",
                        "#.##.####..#..#",
                        "####..###..####",
                        "####..####.####",
                        "###..#..#..#..#",
                        "####.#####.####",
                        "####.####..####" };

char ecran[4][16];

struct {
	 int ora, minut;
       } timp;

FILE *in, *out;


void citire(void)
{
  int i, j;
  in = fopen("ceas.in", "rt");
  for (i=0; i<5; ++i)
    for (j=0; j<4; ++j)
      fscanf(in, "%s", ecran[j] + 3 * i);
  fclose(in);
}

int potrivire(int cifra, int care)
{
  int i;
  for (i=0; i<15; ++i)
    if (ecran[cifra][i] == '#' && sablon[care][i] == '.')
      return 0;
  return 1;
}

void rezolva(void)
{
  int i, j;
  for (i=0; i<24; ++i)
    for (j=0; j<60; ++j)
      if (potrivire(0, i/10) && potrivire(1, i%10) &&
	  potrivire(2, j/10) && potrivire(3, j%10))
	   {
	     timp.ora = i;
	     timp.minut = j;
	     return;
	   }
}

void afisare(void)
{
  out=fopen("ceas.out", "wt");
  fprintf(out, "%02d:%02d\n", timp.ora, timp.minut);
  fclose(out);
}

int main(void)
{
  citire();
  rezolva();
  afisare();
  return 0;
}
