Program Ceas;
Const Sablon: Array [0..9] Of String[15] = ( '####.##.##.####',
                                             '.#..#..#..#..#.',
                                             '###..#####..###',
                                             '###..####..####',
                                             '#.##.####..#..#',
                                             '####..###..####',
                                             '####..####.####',
                                             '###..#..#..#..#',
                                             '####.#####.####',
                                             '####.####..####' );
Var Ecran    : Array [1..4] Of String[15];
    Timp     : Record
                 Ora, Minut: Integer;
               End;
    Fin, Fout: Text;

Procedure Citire;
Var i, j : Integer;
    Linie: String[15];

Begin
  Assign(Fin, 'ceas.in'); Reset(Fin);
  For i := 1 To 4 Do Ecran[i] := '';
  For i := 1 To 5 Do            {pentru fiecare din cele 5 linii}
    Begin
      ReadLn(Fin, Linie);            {citesc o linie din fisier}
      For j := 1 To 4 Do             {formez cele 4 caractere}
        Ecran[j] := Ecran[j] + Copy(Linie, 4 * (j - 1) + 1, 3);
    End;
  Close(Fin);
End;

Procedure Rezolva;
Var i, j: Integer;

    Function Potrivire(Cifra, Care : Integer) : boolean;
    Var i: Integer;

    Begin
      For i := 1 To 15 Do {parcurg cele 15 caractere ale cifrei de pe ecran}
        If (Ecran[Cifra][i] = '#') And (Sablon[Care][i] = '.') then
          Begin                 {daca am gasit o nepotrivire cu sablonul}
            Potrivire := False; {nu poate fi asta cifra!!!}
            Exit;
          End;

      Potrivire := True;        {nu am gasit nici o nepotrivire! asta e!}
    End;

Begin
  For i := 0 To 23 Do         {parcurg toate orele posibile}
    For j := 0 To 59 Do       {si minutele posibile}
      If Potrivire(1, i Div 10) And Potrivire(2, i Mod 10) And
         Potrivire(3, j Div 10) And Potrivire(4, j Mod 10) Then
         Begin                {daca nu exista nici o contradictie}
           Timp.Ora := i;     {intre ceea ce am citit si sablon...}
           Timp.Minut := j;   {am gasit oar si minutul}
           Exit;
         End;
End;

Procedure Afisare;
Begin
  Assign(Fout, 'ceas.out'); ReWrite(Fout);
  If Timp.Ora<10 Then Write(Fout, '0');
  Write(Fout, Timp.Ora, ':');
  If Timp.Minut<10 Then
  Write(Fout, '0');
  WriteLn(Fout, Timp.Minut);
  Close(Fout);
End;

Begin
  Citire;
  Rezolva;
  Afisare;
End.
